<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Models;
use App\Http\Base\BaseModel;

class PenerimaanmakananModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "penerimaanmakanan";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "penerimaanmakanan";

	/**
	* primary key from table remember eloquent doesnt support composite primary key
	*/
	protected $primaryKey = "id";
	/**
	* check the incrementing boolean if the incrementing from database is false then the value is false by default
	*/
	// public $incrementing = false;
	/**
	* fillable property for eloquent attribute cast
	*/
	protected $fillable=[
		"id", "mrNumber", "requesterId", "type", "kapalId", "locationId", "accountId", "date", "totalBarang",
		"voyageKode",
		"voyageStart",
		"voyageEnd",
		"status",
		"feedback",
		"tglApproved",
		"komentar", "date_updated"
	];
	/**
	* Creating raw object from table that, this purpose for making you easier for remembering all attribute
	*/


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
    */
	protected $aliasPaging = [
		"date" => "penerimaanmakanan.date", 
		"status" => "penerimaanmakanan.status", 
		"mrNumber" => "penerimaanmakanan.mrNumber",
		"voyageStart" => "penerimaanmakanan.voyageStart",
		"voyageEnd" => "penerimaanmakanan.voyageEnd",
		"voyageKode" => "penerimaanmakanan.voyageKode"
	];

	/**
	* relation from ' . kapal . ' by ' . kapalId 
	* join kapal on kapal.id = penerimaanmakanan.kapalId
	* this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	* but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	* @param string $alias
	* @return $this
	*/
	public function joinRelationKapalId($alias = "kapalId")
	{
		$this->getQuery()->join("kapal as $alias", "$alias.id", "=", "penerimaanmakanan.kapalId");
		return $this;
	}
	/**
	* relation from ' . lokasiitem . ' by ' . locationId 
	* join lokasiitem on lokasiitem.id = penerimaanmakanan.locationId
	* this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	* but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	* @param string $alias
	* @return $this
	*/
	public function joinRelationLocationId($alias = "locationId")
	{
		$this->getQuery()->join("lokasiitem as $alias", "$alias.id", "=", "penerimaanmakanan.locationId");
		return $this;
	}
	/**
	* relation from ' . users . ' by ' . userId 
	* join users on users.id = penerimaanmakanan.userId
	* this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	* but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	* @param string $alias
	* @return $this
	*/
	public function joinRelationRequesterId($alias = "requesterId")
	{
		$this->getQuery()->join("users as $alias", "$alias.id", "=", "penerimaanmakanan.requesterId");
		return $this;
	}
	/**
	* relation from ' . itempenerimaanmakanan . ' by ' . penerimaanMakananId 
	* join itempenerimaanmakanan on itempenerimaanmakanan.penerimaanMakananId = penerimaanmakanan.id
	* this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	* but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	* @param string $alias
	* @return $this
	*/
	public function joinRelationItempenerimaanmakananId($alias = "itempenerimaanmakanan")
	{
		$this->getQuery()->join("itempenerimaanmakanan as $alias", "$alias.mrNumber", "=", "penerimaanmakanan.mrNumber");
		return $this;
	}


	public function joinRelationAccountId($alias = "account")
	{
		$this->getQuery()->leftjoin("account as $alias", "$alias.id", "=", "penerimaanmakanan.accountId");
		return $this;
	}

	public function joinRelationVoyageKode($alias = "voyageKode")
	{
		$this->getQuery()->leftjoin("voyages as $alias", function($join) use ($alias) {
			$join->on("$alias.voyageKode", "=", "penerimaanmakanan.voyageKode");
			$join->on("$alias.kapalId", "=", "penerimaanmakanan.kapalId");
		});
		return $this;
	}

	public function joinRelationApproverId($alias = "approverId")
	{
		$this->getQuery()->leftjoin("users as $alias", "$alias.id", "=", "penerimaanmakanan.approverId");
		return $this;
	}
}